// **********************************************************************
//
// Copyright (c) 2003-2018 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.7.1
//
// <auto-generated>
//
// Generated from file `Session.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Glacier2;

/**
 * The session manager for username/password authenticated users that
 * is responsible for managing {@link Session} objects. New session objects
 * are created by the {@link Router} object calling on an application-provided
 * session manager. If no session manager is provided by the application,
 * no client-visible sessions are passed to the client.
 *
 * @see Router
 * @see Session
 *
 **/
public interface SessionManagerPrx extends Ice.ObjectPrx
{
    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @return A proxy to the newly created session.
     *
     * @throws CannotCreateSessionException Raised if the session
     * cannot be created.
     *
     **/
    public SessionPrx create(String userId, SessionControlPrx control)
        throws CannotCreateSessionException;

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param context The Context map to send with the invocation.
     * @return A proxy to the newly created session.
     *
     * @throws CannotCreateSessionException Raised if the session
     * cannot be created.
     *
     **/
    public SessionPrx create(String userId, SessionControlPrx control, java.util.Map<String, String> context)
        throws CannotCreateSessionException;

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId, SessionControlPrx control);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param context The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId, SessionControlPrx control, java.util.Map<String, String> context);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId, SessionControlPrx control, Ice.Callback cb);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId, SessionControlPrx control, java.util.Map<String, String> context, Ice.Callback cb);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId, SessionControlPrx control, Callback_SessionManager_create cb);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId, SessionControlPrx control, java.util.Map<String, String> context, Callback_SessionManager_create cb);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param responseCb The lambda response callback.
     * @param userExceptionCb The lambda user exception callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId,
                                        SessionControlPrx control,
                                        IceInternal.Functional_GenericCallback1<SessionPrx> responseCb,
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> userExceptionCb,
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param responseCb The lambda response callback.
     * @param userExceptionCb The lambda user exception callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId,
                                        SessionControlPrx control,
                                        IceInternal.Functional_GenericCallback1<SessionPrx> responseCb,
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> userExceptionCb,
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb,
                                        IceInternal.Functional_BoolCallback sentCb);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param userExceptionCb The lambda user exception callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId,
                                        SessionControlPrx control,
                                        java.util.Map<String, String> context,
                                        IceInternal.Functional_GenericCallback1<SessionPrx> responseCb,
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> userExceptionCb,
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb);

    /**
     * Create a new session.
     *
     * @param userId The user id for the session.
     *
     * @param control A proxy to the session control object.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param userExceptionCb The lambda user exception callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_create(String userId,
                                        SessionControlPrx control,
                                        java.util.Map<String, String> context,
                                        IceInternal.Functional_GenericCallback1<SessionPrx> responseCb,
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> userExceptionCb,
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb,
                                        IceInternal.Functional_BoolCallback sentCb);

    /**
     * Create a new session.
     *
     * @param result The asynchronous result object.
     * @return A proxy to the newly created session.
     *
     * @throws CannotCreateSessionException Raised if the session
     * cannot be created.
     *
     **/
    public SessionPrx end_create(Ice.AsyncResult result)
        throws CannotCreateSessionException;
}
