// **********************************************************************
//
// Copyright (c) 2003-2018 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.7.1
//
// <auto-generated>
//
// Generated from file `LocalException.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Ice;

/**
 * This exception indicates a DNS problem. For details on the cause,
 * {@link DNSException#error} should be inspected.
 *
 **/
public class DNSException extends LocalException
{
    public DNSException()
    {
        this.error = 0;
        this.host = "";
    }

    public DNSException(Throwable cause)
    {
        super(cause);
        this.error = 0;
        this.host = "";
    }

    public DNSException(int error, String host)
    {
        this.error = error;
        this.host = host;
    }

    public DNSException(int error, String host, Throwable cause)
    {
        super(cause);
        this.error = error;
        this.host = host;
    }

    public String
    ice_id()
    {
        return "::Ice::DNSException";
    }

    /**
     * The error number describing the DNS problem. For C++ and Unix,
     * this is equivalent to <tt>h_errno</tt>. For C++ and
     * Windows, this is the value returned by
     * <tt>WSAGetLastError()</tt>.
     *
     **/
    public int error;

    /**
     * The host name that could not be resolved.
     *
     **/
    public String host;

    public static final long serialVersionUID = 1354845362L;
}
